#!/usr/bin/env python
# -*- mode:Python; tab-width: 4 -*-
"""
Little hack for Etxebide. Goes through the html files fixing the
.jsp absolute urls to non-existant local files, which is a hack.
"""

import re
import os
import html_parser
import cms_freeze


__author__ = "Grzegorz Adam Hankiewicz <gradha@efaber.net>"
__date__ = "May 2003"
__version__ = "$Revision: 1.4 $"
__credits__ = ""


# Change the next value to zero if you want q01 links to use a
# relative path instead of a server absolute path
absolute_urls = 1
jsp = re.compile(r"(.*?)etxebide.efaber.net/q01(.*)")


def main(directory, extension):
    """Entry point of the appliaction."""
    for file, dummy in cms_freeze.walk_local_files(extension, directory):
        process_jsp_links(file, directory)
    print "Done"
    print """Remember that now you can run point_etxebide_jsp_to_holder_file.py
if you want to make all local relative jsp links point to a special holder
file, to avoid `local 404' errors."""


def process_jsp_links(filename, base_directory):
    """Makes all *q01* relative links, even when file doesn't exist."""
    print "Searching jsp links in", filename
    input = file(filename, "rb")
    data = input.read()
    input.close()
    substitutions = {}
    l = html_parser.Link_extractor(data, 0)
    for link in l.get_links():
        match = jsp.search(link)
        if match and link not in substitutions:
            if absolute_urls:
                local = match.expand(r"/q01\2")
            else:
                local = os.path.join(base_directory, match.expand(r"q01\2"))
            substitutions[link] = local
            print " `%s' -> `%s'" % (link, local)

    # ok, make changes if links were found
    if not substitutions:
        return
        
    t = html_parser.Link_transformer(filename, "", substitutions,
        clean_html = 0, forced_local_links = not absolute_urls,
        relative_local_links = not absolute_urls)
    output = file(filename, "wb")
    output.write(t.get_data())
    output.close()


if __name__ == "__main__":
    import sys
    if "run" in sys.argv[1:]:
        main("etxebide", ".htm")
    else:
        print """
Little hack for Etxebide. Goes through the html files fixing the
.jsp absolute urls to non-existant local files, which is a hack.
All the useful values are hardcoded. Usually you will be running
this after freeze_etxebide.py.

To run this script for real, you have to pass the parameter
"run". Otherwise only this boring screen is printed.  Don't worry
about running this script multiple times, that's harmless.

Note that this script can be used to fix the jsp urls in two ways:
it can create local relative links (../../whatever) of server
absolute paths (/whatever). The selection of one or another
depends on a hardcoded variable at the beginning of the script,
named absolute_urls. Please change that if you need to modify
the behaviour.
"""
