#!/usr/bin/env python
# -*- mode:Python; tab-width: 4 -*-

from distutils.core import setup
import os
import cms_freeze

py_modules = ["html_parser", "css_parser", "cms_freeze"]
binaries = ["cms_freeze.py", "link_grep.py"]
examples = ["freeze_efaber.py", "freeze_etxebide.py", "freeze_hegoa.py",
    "post_process_etxebide.py", "point_etxebide_jsp_to_holder_file.py"]
doc_files = ["README", "INSTALL", "LICENSE", "MANIFEST"]

if __name__ == "__main__":
    if os.path.isdir("CVS"):
        os.system("cvs2cl.pl -t")
        os.system("touch MANIFEST.in")
    setup(name = "cms_freeze",
        version = "1.0.1",
        description = "CMS freezing tools",
        author = cms_freeze.__author__,
        author_email = "gradha@efaber.net",
        url = "http://www.efaber.net/",
        py_modules = py_modules,
        scripts = binaries,
        data_files = [ ("doc/cms_freeze", doc_files),
            ("doc/cms_freeze/samples", examples),
        ]
    )
